//
//  StickLayer.m
//  Game01
//
//  Created by Kansuke Nishida on 11/09/23.
//  Copyright 2011年 tonosamart. All rights reserved.
//

#import "StickLayer.h"
#import "Stick.h"
#import "Constants.h"

@implementation StickLayer

enum {
    SPRITE_NULL,
    SPRITE_STICK,
    SPRITE_STICK_U,
    SPRITE_STICK_UR,
    SPRITE_STICK_R,
    SPRITE_STICK_RD,
    SPRITE_STICK_D,
    SPRITE_STICK_DL,
    SPRITE_STICK_L,
    SPRITE_STICK_LU,
    SPRITE_BUTTON_A,
    SPRITE_BUTTON_A_ON,
    SPRITE_BUTTON_B,
    SPRITE_BUTTON_B_ON,
    SPRITE_BUTTON_C,
    SPRITE_BUTTON_C_ON,
    SPRITE_BUTTON_D,
    SPRITE_BUTTON_D_ON
};

@synthesize stickUtouchArray;
@synthesize stickRtouchArray;
@synthesize stickDtouchArray;
@synthesize stickLtouchArray;

@synthesize buttonAtouchArray;
@synthesize buttonBtouchArray;
@synthesize buttonCtouchArray;
@synthesize buttonDtouchArray;

-(id)init{
	if((self = [super init])){
		//イベントの設定
		self.isTouchEnabled = YES;
		self.isAccelerometerEnabled = NO;
		//globalの初期化
		self.stickUtouchArray = [NSMutableArray array];
		self.stickRtouchArray = [NSMutableArray array];
		self.stickDtouchArray = [NSMutableArray array];
		self.stickLtouchArray = [NSMutableArray array];
        
		self.buttonAtouchArray = [NSMutableArray array];
		self.buttonBtouchArray = [NSMutableArray array];
		self.buttonCtouchArray = [NSMutableArray array];
		self.buttonDtouchArray = [NSMutableArray array];
		//レイヤーの初期化
		[self initLayer];
	}
	return self;
}

-(void)dealloc{
	[stickUtouchArray release];
	[stickRtouchArray release];
	[stickDtouchArray release];
	[stickLtouchArray release];
	[buttonAtouchArray release];
	[buttonBtouchArray release];
	[buttonCtouchArray release];
	[buttonDtouchArray release];
	[super dealloc];
}

#pragma mark main

-(void)initLayer{
    
	CCSprite *sprite;
	
	CGPoint stickPosition = ccp(0, 0);
    stickPosition.x = 70;
    stickPosition.y = 67;
	
    sprite = [CCSprite spriteWithFile:@"PAD-STICK.png"];
    [sprite setPosition:ccp(70, 67)];
    [sprite setOpacity:128];
    [self addChild:sprite z:SPRITE_STICK tag:SPRITE_STICK];
    
	sprite = [CCSprite spriteWithFile:@"STICK-ON_01.png"];
	[sprite setPosition:ccp(stickPosition.x - 43, stickPosition.y + 39)];
	[sprite setVisible:NO];
	[sprite setOpacity:128];
	[self addChild:sprite z:SPRITE_STICK_LU tag:SPRITE_STICK_LU];
	
	sprite = [CCSprite spriteWithFile:@"STICK-ON_02.png"];
	[sprite setPosition:ccp(stickPosition.x, stickPosition.y + 39)];
	[sprite setVisible:NO];
	[sprite setOpacity:128];
	[self addChild:sprite z:SPRITE_STICK_U tag:SPRITE_STICK_U];
    
	sprite = [CCSprite spriteWithFile:@"STICK-ON_03.png"];
	[sprite setPosition:ccp(stickPosition.x + 43, stickPosition.y + 39)];
	[sprite setVisible:NO];
	[sprite setOpacity:128];
	[self addChild:sprite z:SPRITE_STICK_UR tag:SPRITE_STICK_UR];
	
	sprite = [CCSprite spriteWithFile:@"STICK-ON_04.png"];
	[sprite setPosition:ccp(stickPosition.x - 35, stickPosition.y - 4)];
	[sprite setVisible:NO];
	[sprite setOpacity:128];
	[self addChild:sprite z:SPRITE_STICK_L tag:SPRITE_STICK_L];	
    
	sprite = [CCSprite spriteWithFile:@"STICK-ON_05.png"];
	[sprite setPosition:ccp(stickPosition.x + 35, stickPosition.y - 4)];
	[sprite setVisible:NO];
	[sprite setOpacity:128];
	[self addChild:sprite z:SPRITE_STICK_R tag:SPRITE_STICK_R];
    
	sprite = [CCSprite spriteWithFile:@"STICK-ON_06.png"];
	[sprite setPosition:ccp(stickPosition.x - 43, stickPosition.y - 43)];
	[sprite setVisible:NO];
	[sprite setOpacity:128];
	[self addChild:sprite z:SPRITE_STICK_DL tag:SPRITE_STICK_DL];
	
	sprite = [CCSprite spriteWithFile:@"STICK-ON_07.png"];
	[sprite setPosition:ccp(stickPosition.x, stickPosition.y - 43)];
    [sprite setVisible:NO];
	[sprite setOpacity:128];
	[self addChild:sprite z:SPRITE_STICK_D tag:SPRITE_STICK_D];
    
	sprite = [CCSprite spriteWithFile:@"STICK-ON_08.png"];
	[sprite setPosition:ccp(stickPosition.x + 43, stickPosition.y - 43)];
	[sprite setVisible:NO];
	[sprite setOpacity:128];
	[self addChild:sprite z:SPRITE_STICK_RD tag:SPRITE_STICK_RD];
	
	CGPoint buttonA = ccp(0,0);
	
    buttonA.x = 432;
    buttonA.y = 48;

	if(TONO_IS_BUTTON_A){
		sprite = [CCSprite spriteWithFile:@"PAD-BUTTON-A.png"];
		[sprite setPosition:ccp(buttonA.x, buttonA.y)];
		[sprite setOpacity:128];
		[self addChild:sprite z:SPRITE_BUTTON_A tag:SPRITE_BUTTON_A];	
		
		sprite = [CCSprite spriteWithFile:@"PAD-BUTTON-ON.png"];
		[sprite setPosition:ccp(buttonA.x, buttonA.y)];
		[sprite setVisible:NO];
		[sprite setOpacity:128];
		[self addChild:sprite z:SPRITE_BUTTON_A_ON tag:SPRITE_BUTTON_A_ON];	
	}
	if(TONO_IS_BUTTON_B){
		sprite = [CCSprite spriteWithFile:@"PAD-BUTTON-B.png"];
		[sprite setPosition:ccp(buttonA.x - 74, buttonA.y)];
		[sprite setOpacity:128];
		[self addChild:sprite z:SPRITE_BUTTON_B tag:SPRITE_BUTTON_B];	
		
		sprite = [CCSprite spriteWithFile:@"PAD-BUTTON-ON.png"];
		[sprite setPosition:ccp(buttonA.x - 74, buttonA.y)];
		[sprite setVisible:NO];
		[sprite setOpacity:128];
		[self addChild:sprite z:SPRITE_BUTTON_B_ON tag:SPRITE_BUTTON_B_ON];	
	}
	if(TONO_IS_BUTTON_C){
		sprite = [CCSprite spriteWithFile:@"PAD-BUTTON-C.png"];
		[sprite setPosition:ccp(buttonA.x - 148, buttonA.y)];
		[sprite setOpacity:128];
		[self addChild:sprite z:SPRITE_BUTTON_C tag:SPRITE_BUTTON_C];	
		
		sprite = [CCSprite spriteWithFile:@"PAD-BUTTON-ON.png"];
		[sprite setPosition:ccp(buttonA.x - 148, buttonA.y)];
		[sprite setVisible:NO];
		[sprite setOpacity:128];
		[self addChild:sprite z:SPRITE_BUTTON_C_ON tag:SPRITE_BUTTON_C_ON];	
	}
	if(TONO_IS_BUTTON_D){
		sprite = [CCSprite spriteWithFile:@"PAD-BUTTON-D.png"];
		[sprite setPosition:ccp(buttonA.x - 222, buttonA.y)];
		[sprite setOpacity:128];
		[self addChild:sprite z:SPRITE_BUTTON_D tag:SPRITE_BUTTON_D];	
		
		sprite = [CCSprite spriteWithFile:@"PAD-BUTTON-ON.png"];
		[sprite setPosition:ccp(buttonA.x - 222, buttonA.y)];
		[sprite setVisible:NO];
		[sprite setOpacity:128];
		[self addChild:sprite z:SPRITE_BUTTON_D_ON tag:SPRITE_BUTTON_D_ON];	
	}
	
}

#pragma mark EVENT
-(void)ccTouchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
	Stick* stick = [Stick stick];
	
	for(UITouch* touch in touches){
		CGPoint touchPoint = [touch locationInView:[touch view]];
		touchPoint = [[CCDirector sharedDirector] convertToGL:touchPoint];
		
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_U]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_U] setVisible:YES];
			[self.stickUtouchArray addObject:touch];
			stick.isUp = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_UR]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_U] setVisible:YES];
			[self.stickUtouchArray addObject:touch];
			stick.isUp = TRUE; 
			[[self getChildByTag:SPRITE_STICK_R] setVisible:YES];
			[self.stickRtouchArray addObject:touch];
			stick.isRight = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_R]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_R] setVisible:YES];
			[self.stickRtouchArray addObject:touch];
			stick.isRight = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_RD]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_R] setVisible:YES];
			[self.stickRtouchArray addObject:touch];
			stick.isRight = TRUE; 
			[[self getChildByTag:SPRITE_STICK_D] setVisible:YES];
			[self.stickDtouchArray addObject:touch];
			stick.isDown = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_D]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_D] setVisible:YES];
			[self.stickDtouchArray addObject:touch];
			stick.isDown = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_DL]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_D] setVisible:YES];
			[self.stickDtouchArray addObject:touch];
			stick.isDown = TRUE; 
			[[self getChildByTag:SPRITE_STICK_L] setVisible:YES];
			[self.stickLtouchArray addObject:touch];
			stick.isLeft = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_L]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_L] setVisible:YES];
			[self.stickLtouchArray addObject:touch];
			stick.isLeft = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_LU]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_L] setVisible:YES];
			[self.stickLtouchArray addObject:touch];
			stick.isLeft = TRUE; 
			[[self getChildByTag:SPRITE_STICK_U] setVisible:YES];
			[self.stickUtouchArray addObject:touch];
			stick.isUp = TRUE; 
		}
		
		if(TONO_IS_BUTTON_A){
			if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_BUTTON_A]], touchPoint)){
				[[self getChildByTag:SPRITE_BUTTON_A_ON] setVisible:YES];
				[self.buttonAtouchArray addObject:touch];
				stick.isA = TRUE; 
			}
		}
		if(TONO_IS_BUTTON_B){
			if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_BUTTON_B]], touchPoint)){
				[[self getChildByTag:SPRITE_BUTTON_B_ON] setVisible:YES];
				[self.buttonBtouchArray addObject:touch];
				stick.isB = TRUE; 
			}
		}
		if(TONO_IS_BUTTON_C){
			if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_BUTTON_C]], touchPoint)){
				[[self getChildByTag:SPRITE_BUTTON_C_ON] setVisible:YES];
				[self.buttonCtouchArray addObject:touch];
				stick.isC = TRUE; 
			}		
		}
		if(TONO_IS_BUTTON_D){
			if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_BUTTON_D]], touchPoint)){
				[[self getChildByTag:SPRITE_BUTTON_D_ON] setVisible:YES];
				[self.buttonDtouchArray addObject:touch];
				stick.isD = TRUE; 
			}		
		}
	}
}

-(void)ccTouchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
	Stick* stick = [Stick stick];
	
	for(UITouch* touch in touches){
		CGPoint touchPoint = [touch locationInView:[touch view]];
		touchPoint = [[CCDirector sharedDirector] convertToGL:touchPoint];

		[self.stickUtouchArray removeObject:touch];
		if([self.stickUtouchArray count] == 0){
			[[self getChildByTag:SPRITE_STICK_U] setVisible:NO];
			stick.isUp = FALSE; 
		}
		[self.stickRtouchArray removeObject:touch];
		if([self.stickRtouchArray count] == 0){
			[[self getChildByTag:SPRITE_STICK_R] setVisible:NO];
			stick.isRight = FALSE; 
		}
		[self.stickDtouchArray removeObject:touch];
		if([self.stickDtouchArray count] == 0){
			[[self getChildByTag:SPRITE_STICK_D] setVisible:NO];
			stick.isDown = FALSE; 
		}
		[self.stickLtouchArray removeObject:touch];
		if([self.stickLtouchArray count] == 0){
			[[self getChildByTag:SPRITE_STICK_L] setVisible:NO];
			stick.isLeft = FALSE; 
		}
		
		if(TONO_IS_BUTTON_A){
			if(FALSE == CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_BUTTON_A]], touchPoint)){
                [self.buttonAtouchArray removeObject:touch];
                if([self.buttonAtouchArray count] == 0){
                    [[self getChildByTag:SPRITE_BUTTON_A_ON] setVisible:NO];
                    stick.isA = FALSE; 
                }		
            }
		}
		if(TONO_IS_BUTTON_B){
			if(FALSE == CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_BUTTON_B]], touchPoint)){
                [self.buttonBtouchArray removeObject:touch];
                if([self.buttonBtouchArray count] == 0){
                    [[self getChildByTag:SPRITE_BUTTON_B_ON] setVisible:NO];
                    stick.isB = FALSE; 
                }
            }		
		}
		if(TONO_IS_BUTTON_C){
			if(FALSE == CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_BUTTON_C]], touchPoint)){
                [self.buttonCtouchArray removeObject:touch];
                if([self.buttonCtouchArray count] == 0){
                    [[self getChildByTag:SPRITE_BUTTON_C_ON] setVisible:NO];
                    stick.isC = FALSE; 
                }
            }
		}
		if(TONO_IS_BUTTON_D){
			if(FALSE == CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_BUTTON_D]], touchPoint)){
                [self.buttonDtouchArray removeObject:touch];
                if([self.buttonDtouchArray count] == 0){
                    [[self getChildByTag:SPRITE_BUTTON_D_ON] setVisible:NO];
                    stick.isD = FALSE; 
                }
            }
		}				
	}
	for(UITouch* touch in touches){
		CGPoint touchPoint = [touch locationInView:[touch view]];
		touchPoint = [[CCDirector sharedDirector] convertToGL:touchPoint];
		
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_U]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_U] setVisible:YES];
			[self.stickUtouchArray addObject:touch];
			stick.isUp = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_UR]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_U] setVisible:YES];
			[self.stickUtouchArray addObject:touch];
			stick.isUp = TRUE; 
			[[self getChildByTag:SPRITE_STICK_R] setVisible:YES];
			[self.stickRtouchArray addObject:touch];
			stick.isRight = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_R]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_R] setVisible:YES];
			[self.stickRtouchArray addObject:touch];
			stick.isRight = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_RD]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_R] setVisible:YES];
			[self.stickRtouchArray addObject:touch];
			stick.isRight = TRUE; 
			[[self getChildByTag:SPRITE_STICK_D] setVisible:YES];
			[self.stickDtouchArray addObject:touch];
			stick.isDown = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_D]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_D] setVisible:YES];
			[self.stickDtouchArray addObject:touch];
			stick.isDown = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_DL]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_D] setVisible:YES];
			[self.stickDtouchArray addObject:touch];
			stick.isDown = TRUE; 
			[[self getChildByTag:SPRITE_STICK_L] setVisible:YES];
			[self.stickLtouchArray addObject:touch];
			stick.isLeft = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_L]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_L] setVisible:YES];
			[self.stickLtouchArray addObject:touch];
			stick.isLeft = TRUE; 
		}
		if(CGRectContainsPoint([Constants rectForSprite:(CCSprite*)[self getChildByTag:SPRITE_STICK_LU]], touchPoint)){
			[[self getChildByTag:SPRITE_STICK_L] setVisible:YES];
			[self.stickLtouchArray addObject:touch];
			stick.isLeft = TRUE; 
			[[self getChildByTag:SPRITE_STICK_U] setVisible:YES];
			[self.stickUtouchArray addObject:touch];
			stick.isUp = TRUE; 
		}
	}
}

-(void)ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
	Stick* stick = [Stick stick];
    
	for(UITouch* touch in touches){
		[self.stickUtouchArray removeObject:touch];
		if([self.stickUtouchArray count] == 0){
			[[self getChildByTag:SPRITE_STICK_U] setVisible:NO];
			stick.isUp = FALSE; 
		}
		[self.stickRtouchArray removeObject:touch];
		if([self.stickRtouchArray count] == 0){
			[[self getChildByTag:SPRITE_STICK_R] setVisible:NO];
			stick.isRight = FALSE; 
		}
		[self.stickDtouchArray removeObject:touch];
		if([self.stickDtouchArray count] == 0){
			[[self getChildByTag:SPRITE_STICK_D] setVisible:NO];
			stick.isDown = FALSE; 
		}
		[self.stickLtouchArray removeObject:touch];
		if([self.stickLtouchArray count] == 0){
			[[self getChildByTag:SPRITE_STICK_L] setVisible:NO];
			stick.isLeft = FALSE; 
		}
		
		if(TONO_IS_BUTTON_A){
			[self.buttonAtouchArray removeObject:touch];
			if([self.buttonAtouchArray count] == 0){
				[[self getChildByTag:SPRITE_BUTTON_A_ON] setVisible:NO];
				stick.isA = FALSE; 
			}		
		}
		if(TONO_IS_BUTTON_B){
			[self.buttonBtouchArray removeObject:touch];
			if([self.buttonBtouchArray count] == 0){
				[[self getChildByTag:SPRITE_BUTTON_B_ON] setVisible:NO];
				stick.isB = FALSE; 
			}		
		}
		if(TONO_IS_BUTTON_C){
			[self.buttonCtouchArray removeObject:touch];
			if([self.buttonCtouchArray count] == 0){
				[[self getChildByTag:SPRITE_BUTTON_C_ON] setVisible:NO];
				stick.isC = FALSE; 
			}		
		}
		if(TONO_IS_BUTTON_D){
			[self.buttonDtouchArray removeObject:touch];
			if([self.buttonDtouchArray count] == 0){
				[[self getChildByTag:SPRITE_BUTTON_D_ON] setVisible:NO];
				stick.isD = FALSE; 
			}				
		}
	}
}

@end
